﻿/**************************************
*   04.04.2010 - 17.09.2010
*
*   РАБОТА С ПЛЕЙЛИСТАМИ
*
***************************************/

// CLASS "Playlist Manager"
function PlaylistManager(){
    this.tvChannels           = null;                        // new PlaylistSTB (ROOT_TV_CHANNELS, ROOT_TV_CHANNELS);
    this.favorites            = null;                        // new PlaylistSTB (ROOT_FAVORITES, ROOT_FAVORITES)
    this.lastIndex            = 0;                           // последний использованный индекс
    // Methods
    this.refreshPlaylist      = plman_refreshPlaylist;       // заполняет this.tvChannels OR this.favorites
    this.createPlaylist       = plman_createPlaylist;        //
    this.getPlaylist          = plman_getPlaylist;           // возвращает массив из элементов dataset = содержимого данного плейлиста
    this.getDatasetLocation   = plman_getDatasetLocation;    // 
    this.getPlaylistByPathname= plman_getPlaylistByPathname; // 
    this.saveAllPlaylists     = plman_saveAllPlaylists;      // Saves ALL playlists as xml-like section in STB_PARAMS
    this.deletePlaylist       = plman_deletePlaylist;        // 
    this.getTVChannelByIndex  = plman_getTVChannelByIndex;
    this.timeShift_check      = plman_timeShift_check; 
    this.getAllGroups         = function(){
        var tvchGroups = this.tvChannels.getAllGroups();
        var favGroups  = this.favorites.getAllGroups();
        return [tvchGroups,favGroups];
    };

    // МЕТОД "ПРИСВОИТЬ ИНДЕКС НОДУ"
    this.setIndex = function(node){
        if (this.lastIndex < PM_INDEXES_RES) {
            var index = ++this.lastIndex;
            node.index = index;
        }
    };

    // МЕТОД "ИНДЕКСИРОВАТЬ МАССИВ ТВ-КАНАЛОВ"
    this.reindexTVChannels = function(){
        this.freeAllIndexes();
        this.lastIndex = this.tvChannels.indexIt(this.lastIndex);
    };

    // МЕТОД "ОСВОБОДИТЬ ВСЕ ИНДЕКСЫ"
    this.freeAllIndexes = function(){
        this.lastIndex = 0;
    };

    // МЕТОД 
    this.getRootNode = function(name){
        if (name == ROOT_TV_CHANNELS) {
            return this.tvChannels;
        }
        else{
            return this.favorites;
        }
    };
    this.freeAllIndexes();
}

// METHOD
// root = ROOT_TV_CHANNELS | ROOT_FAVORITES
function plman_refreshPlaylist(root,check){
    _debug("plman_refreshPlaylist("+root+")");
    var tmp = [],
    section = plman_getSection(PLAYLIST_SECTION_NAME,'stb','inner')[1],
    data;
    if (root == ROOT_TV_CHANNELS) {
        this.tvChannels = new PlaylistSTB (ROOT_TV_CHANNELS, ROOT_TV_CHANNELS);
    }
    else{
        this.favorites = new PlaylistSTB (ROOT_FAVORITES, ROOT_FAVORITES);
    }
    if (section) {
        // Здесь section - это секция плейлистов (групп). Она состоит из 2-x секций: ROOT_TV_CHANNELS и ROOT_FAVORITES
        //_debug(root);
        section = plman_getSection (root, section, 'inner')[1];
        if (section) {
            section = section.replace(/\r/gm,'');
            section = section.replace(/\n/gm,'');
            //_debug(section);
            //section = section.replace(/ /gm,'');
            //section = section.replace(/\s/gm,'');
            //section = '[]';//в случае критической ошибки при загрузке плэйлиста нужно раскоментировать эту строку, обнулить плэйлист и закоментировать назад
            // Здесь section - это секция (массив в виде стринга) ROOT_TV_CHANNELS или ROOT_FAVORITES
            try{
                data = eval(section);                                  // стринг преобразован в массив
            }
            catch(e){
                if(e == 'SyntaxError: Parse error'){
                    section = section.substr(0,(section.indexOf(']')+1));
                    try{
                        data = eval(section);
                    }
                    catch(e){
                        _debug(e);
                        data = ''
                    }
                    _debug(section);
                }
            }
            data = plman_tv_unescape(data);
            if (root == ROOT_TV_CHANNELS) {
                //data = plman_tv_unescape(data);
                if(this.timeShift_check(data,check)){
                    this.tvChannels.addItem('', data, true); // overwrite = true
                }                                
            }
            else{
                this.favorites.addItem('', data, true);              // overwrite = true
            }
        }
    }
    // Ввиду того, что здесь происходит создание новых массивов tvChannels и favorites, нужно переформировать pathArray,
    // то есть прописать в массив pathArray те же объекты, что там прописаны, но уже из новых массивов tvChannels и favorites.
    var pArr = pathArray;
    for (var i=0, len=pArr.length; i<len; i++) {
        var node = pArr[i].node;
        //_debug('node.path: '+node.path);
        pArr[i].node = plman.getPlaylistByPathname(node.path);
    }
}

function plman_tv_unescape(data){  
    for(var i=0; i<data.length;i++){
        data[i].name = unescape(data[i].name);
        if(data[i].data){
            data[i].data = plman_tv_unescape(data[i].data);
            continue;
        }
        data[i].source = unescape(data[i].source);
    }
    return data;
}

//функция проверки ТВ каналов на возможность TimeShift солюшена
function plman_timeShift_check(data,check){
    if(new RegExp("MAG200").test(model_type)){
        return true;
    }    
    var a = data.length;
    var save = false;
    if(a>0){     
        var temp_arr = "";
        var arr = JSON.parse(JSON.stringify(data));        
        var temp = plman_timeShift_check_data(data,check);
        temp_arr = JSON.stringify(temp.a, null);        
        save = temp.save;
        if(save){
            //this.tvChannels.addItem('', data, true);
            var section = plman_getSection(PLAYLIST_SECTION_NAME,'stb','inner')[1];
            section2 = plman_getSection('Favorites', section, 'inner')[1];
            section = temp_arr;//.join(',');
            var section2 = plman_getSection(PLAYLIST_SECTION_NAME,'stb','inner')[1];
            section2 = plman_getSection('Favorites', section2, 'inner')[1];
            section = '[groups][TV Channels]'+ section + '[/TV Channels][Favorites]'+section2+'[/Favorites][/groups]';
            stb.WriteCFG(section);
            this.refreshPlaylist(ROOT_TV_CHANNELS,false);
            return false;
        }
    }
    return true;
}

function plman_timeShift_check_data(a,check){
    var l = a.length;
    var save = false;
    for(var i = 0; i< l; i++){            
        if(a[i].data){
            var temp = plman_timeShift_check_data(a[i].data,check);
            a[i].data = temp.a;
            save = save?save:temp.save;
            continue;
        }
        if(typeof a[l-1].tsOn === 'undefined' || check){
            save = true;
            if((typeof a[i].tsOn === 'undefined' || check) && a[i].source){
                var tempsource = unescape(a[i].source).replace(/\r\n|\r|\n/g,'');
                if(/rtp\:|udp\:/.test(tempsource) || /ffrt\s/.test(tempsource)){
                    a[i].tsOn = true;
                } else {
                    a[i].tsOn = false;
                }
            } 
        } 
    }
    return {a : a,save : save};
}

// METHOD
// Создать плейлист (ГРУППУ) в данном ноде
function plman_createPlaylist(node,name){
    var entry = new PlaylistSTB(name, node.path);
    node.data.push(entry);
    return true;
}

// METHOD
// Возвращает содержимое плейлиста в виде объекта группы
// В параметре МАССИВ объектов pathArray
function plman_getPlaylist(pathArray){
    var data = [], group, node;
    if (pathArray[0].node.name == ROOT_TV_CHANNELS) {
        group = this.tvChannels;
    }
    else{
        group = this.favorites;
    }
    if (pathArray.length > 1) {
        for (var i=1; i<pathArray.length; i++) {
            group = group.getEntry(pathArray[i].node.name);
        }
    }
    group.sortIt();
    return group;
}

// METHOD
// Возвращает массив значений [startIdx,selectedRow] для данной группы
function plman_getDatasetLocation(group){
    var datasetLocation = [];
    var datasetIdx;
    var tmp = group.path.split('/');
    tmp.pop();
    var path = tmp.join('/');
    var dataset = this.getPlaylistByPathname(path).data;
    for (var i=0; i<dataset.length; i++) {
        if(dataset[i].name == group.name) {
            datasetIdx = i+1;
            break;
        }
    }
    datasetLocation.push(Math.floor(datasetIdx / table.rowsNumber));
    datasetLocation.push(datasetIdx % table.rowsNumber);
    return datasetLocation;
}

// METHOD
// Возвращает содержимое плейлиста в виде объекта группы
// В параметре путь к плейлисту в виде СТРОКИ имен групп 
// вместе с корневой папкой
function plman_getPlaylistByPathname(pathname){
    var path = unescape(pathname).split('/'), group, node;
    if (path[0] == ROOT_TV_CHANNELS) {
        group = this.tvChannels;
    }
    else{
        group = this.favorites;
    }
    if (path.length > 1) {
        for (var i=1; i<path.length; i++) {
            group = group.getEntry(path[i]);
        }
    }
    if (group) {
        group.sortIt();
    }
    return group;
}

// METHOD
// Сохраняет данные ВСЕХ групп в виде секции в STB_PARAMS
function plman_saveAllPlaylists(){
    var head, body, tail, catalog, tmp, b = '';
    // вычитываем секцию PLAYLISTS из STB_PARAMS
    tmp  = plman_getSection(PLAYLIST_SECTION_NAME,'stb','inner');
    head = tmp[0];              // text before "playlists" with opening tag 
    body = tmp[1];              // pure "playlists" text
    tail = tmp[2];              // text after "playlists" with closing tag 
    if (!body) {
        // секции 'playlists' нет. Создаем ее в конце текста CFG_PARAMS
        // Здесь состояние переменных таково:
        //   head = весь текст CFG_PARAMS;
        //   body = ''
        //   tail = ''
        head += '\n' + TAG_OPEN + PLAYLIST_SECTION_NAME + TAG_CLOSED;
        tail = TAG_OPEN + TAG_END + PLAYLIST_SECTION_NAME + TAG_CLOSED + '\n';
    }
    body  = plman_makeNewSection(this.tvChannels,'outer');
    body += plman_makeNewSection(this.favorites,'outer');
    var result = head + body + tail;
    _debug("stb.WriteCFG(" +result+ ")");
    if (!STB_EMULATION) {
        stb.WriteCFG(result);
    }
    else{
        debugPlaylistSection = result;
    }
    this.refreshPlaylist(ROOT_TV_CHANNELS,true);
    this.refreshPlaylist(ROOT_FAVORITES);
    //
    //  Дополнение от 18.06.2010: сохраняем еще некоторые переменные (не требующие перезагрузки)
    saveSomeVariablesInSTB();
    return true;
}

// METHOD
function plman_deletePlaylist(node){
    var tmp = {};
    var path = node.path.split('/'), group;
    if (path[0] == ROOT_TV_CHANNELS) {
        group = this.tvChannels;
    }
    else{
        group = this.favorites;
    }
    if (path.length > 1) {
        for (var i=1; i<path.length; i++) {
            tmp = group.getEntry(path[i]);
            if (tmp.name == node.name) {
                for (var i=0; i<group.data.length; i++){
                    if (group.data[i].name == node.name) {
                        group.data.splice(i,1);
                        return true;
                    }
                }
            }
            else{
                group = tmp;
            }
        }
    }
}

// METHOD:
function plman_getTVChannelByIndex(idx){
    var tmp, path = ROOT_TV_CHANNELS;
    for (var i=0; i<this.tvChannels.data.length; i++) {
        var item = this.tvChannels.data[i];
        if (item.data) {
            tmp = plman_searchElementByIndex(path,item,idx);
            if (tmp) {
                return tmp;
            }
        }
        if (item.index && item.index == idx) {
            if (!item.pathString) {
                item.pathString = path;
            }
            return item;
        }
    }
    return null;
}

function plman_searchElementByIndex(path,node,idx){
    var tmp;
    if (node.data) {
        path = node.path;
        for (var i=0; i<node.data.length; i++) {
            var item = node.data[i];
            tmp = plman_searchElementByIndex(path,item,idx);
            if (tmp) {
                return tmp;
            }
        }
    }
    if (node.index && node.index == idx) {
        if (!node.pathString) {
            node.pathString = path;
        }
        return node;
    }
    else{
        return null;
    }
}

//----------------
// Из исходного текста text выделяет секцию, помещеную между тэгами <name>, и возвращает массив 
// с тремя кусками исходного текста:
//   [
//     head    - начало текста до секции, 
//     section - искомая секция, 
//     tail    - конец текста после секции
//   ]
// 
// параметры:
//   name:  имя секции
//   text:  текст секции или 'stb' (читает секцию из STB_PARAMS)
//   mode:  "inner": чистая секция | "outer": с тзгами
// 
function plman_getSection(name,text,mode){
    //_debug(' >>> plman_getSection('+name+','+text+','+mode+')');
    var allText, tmp, label, i, section = null, head, tail, delta;
    if (text == 'stb') {
        if (!STB_EMULATION) {
            allText = stb.ReadCFG();
        }
        else{
            allText = debugPlaylistSection;
        }
    }
    else {
        allText = text;
    }
    // extract section
    label = TAG_OPEN + name + TAG_CLOSED;
    i = allText.indexOf(label);
    if (i != -1){
        mode == "inner" ? delta = label.length : delta = 0;
        head = allText.substr(0,i+delta);
        tmp  = allText.substr(i+delta, allText.length);
    }
    else{
        return [allText,'',''];
    }
    label = TAG_OPEN + TAG_END + name + TAG_CLOSED;
    i = tmp.indexOf(label);
    if (i != -1){
        mode == "inner" ? delta = 0 : delta = label.length;
        section = tmp.substr(0, i+delta);
        tail = tmp.substr(i+delta,tmp.length);
    }
    else{
        return [head,tmp,''];
    }
    return [head,section,tail];
}

// Создает из датасета data текст (STRING) тела секции для записи в STB_PARAMS
// Формат записи такой:
//   '[{name:A, size:B, source:C},...,{name:D, size:E, source:F}]'
// Поле size в результирующей записи может отсутствовать
//   mode:  "inner": чистая секция | "outer": обернутая тзгами
function plman_makeNewSection(group,mode){
    var b = '[';
    b += plman_makeStringOfGroup(group);
    b += ']';
    if (mode == 'outer') {
        b = TAG_OPEN + group.name + TAG_CLOSED + b + TAG_OPEN + TAG_END + group.name + TAG_CLOSED;
    }
    return b;
}

// Saves as string only fields
//    name, size, source, data
function plman_makeStringOfGroup(group){
    var b = '';
    for (var i=0; i<group.data.length; i++) {
        var item = group.data[i];
        if (i) {
            b += ',';
        }
        b += '{name:"'+escape(item.name)+'"';
        if (item.size) {
            b += ',size:'+item.size;
        }
        if (item.coreType == CORE_REF) {
            b += ',coreType:"'+item.coreType+'"';
            b += ',fileType:"'+item.fileType+'"';
        }
        if (item.source) {
            b += ',source:"'+escape(item.source)+'"';
        }
        if (item.solution) {
            b += ',solution:"'+item.solution+'"';
        }
        if(item.tsOn){
            b += ',tsOn:"'+item.tsOn+'"';
        }
        if (item.data) {
            b += ',data:[';
            b += plman_makeStringOfGroup(item);
            b += ']';
        }
        b += '}';
    }
    return b;
}

// Определяет тип файла и вставляет в его объект item поля: fileType, objType, locality
// item = {name, size(может не быть), source}
// return: BOOLEAN
function plman_getObjectType(item){
    var objType = null, ext = null, typeInfo, valid;
    ext = getFileExtention(item.name);
    if(/rtp\:\/\/|udp\:\/\/|rtsp\:\/\/|m3u8/.test(item.source)){
        ext = null;
    }
    if (!ext) {
        if (item.data) {
            // это PlaylistSTB
            item.fileType = FILE_TYPE_PLAYLIST_STB;
            item.coreType = CORE_FILE;
            item.locality = LOCALITY_STB;
            return true;
        }
        else{
            if (!(pat_url_signature.test(item.source))) {
                ext = getFileExtention(item.source);
            }
        }
    }
    /*if(!ext && (pat_url_signature.test(item.source))){

  }*/
    if (ext) {
        typeInfo = isTypeKnown(ext);
        if (typeInfo) {
            if(typeInfo.fileType == 'folder' && /rtp\:\/\/|udp\:\/\/|rtsp\:\/\/|m3u8|http\:\/\//.test(item.source)){
                item.fileType = 'stream';
                item.objType  = 'media'; 
            }else{
                item.fileType = typeInfo.fileType;
            }
            if (typeInfo.objType) {
                item.objType  = typeInfo.objType;
            }
            if (pat_url_signature.test(item.source)) {
                item.locality = LOCALITY_HTTP;
            }
            else{
                item.locality = LOCALITY_DISC;
            }
            item.coreType = CORE_REF;
            return true;
            }
        }
        else{
            // нет расширения
            if (CHECK_PAT_URL_SIGNATURE) {
                valid = pat_url_signature.test(item.source);
            }
            else{
                valid = true;
            }
            if (valid) {
                item.fileType = FILE_TYPE_STREAM;
                item.objType  = "media";
                item.locality = LOCALITY_HTTP;
                item.coreType = CORE_REF;
                return true;
            }
        }
        return false;
    }

    // Возвращает объект PlaylistSTB
    // Данные, которые у нас сейчас есть имеют формат:
    //   item = {name, size(?), source(?), data(?) }
    function plman_convertToPlaylistEntry(item,path){
        var entry = {};
        var owner = null;
        if (path) {
            owner = path.split('/')[0];
        }
        //_debug('convertToPlaylistEntry: '+objToString(item));
        if (plman_getObjectType(item)) {
            if (item.data) {
                entry = new PlaylistSTB(item.name,path);
                for (var i=0; i<item.data.length; i++) {
                    var tmp = plman_convertToPlaylistEntry(item.data[i], entry.path);
                    if (tmp) {
                        entry.data.push(tmp);
                    }
                    else{
                        break;
                    }
                }
            }
            entry.name     = item.name;
            entry.coreType = item.coreType;
            entry.fileType = item.fileType;
            entry.locality = item.locality;
            entry.tsOn = item.tsOn;
            if (item.objType) {
                entry.objType  = item.objType;
            }
            if (item.size) {
                entry.size = item.size;
            }
            if (item.source) {
                entry.source   = item.source;
            }
            if (item.solution) {
                entry.solution = item.solution;
            }
            if (owner && owner == ROOT_TV_CHANNELS && entry.fileType == FILE_TYPE_STREAM) {
                if (item.index) {
                    entry.index = item.index;
                }
                else{
                    plman.setIndex(entry);
                }
            }
            return entry;
        }
        else{
            return null;
        }
    }

    //======================================================
    // CLASS "Плейлист STB" (Группа каналов, записей и т.п.)
    // Это "файл" c поведением плейлиста, хранящийся в STB
    function PlaylistSTB (name,path){
        this.name       = name;                   // имя плейлиста (имя секции в STB_PARAMS)
        this.coreType   = CORE_FILE;
        this.fileType   = FILE_TYPE_PLAYLIST_STB;
        this.locality   = LOCALITY_STB;
        this.data       = [];                     // массив объектов записей плейлиста в формате dataset-элементов
        this.accessAttr = GROUP_ACCESS_FREE;
        //
        var tmp = '';
        if (path) {
            // Внимание! Путь к данной ГРУППЕ будет иметь такой формат:  ROOT_NAME / ... / this_group_name
            //           где ROOT_NAME = ROOT_TV_CHANNELS | ROOT_FAVORITES
            var path_arr = path.split('/');
            if (path_arr.length == 1 && path == name) {
                // это корень
                tmp = name;
            }
            else{
                tmp = path + '/' + name;
            }
        }
        this.path = tmp;                          
    }

    //************************************************
    // METHOD "Добавить новый элемент в данную ГРУППУ"
    // if "name" exists adds data as a PlaylistSTB, else adds data as entries
    PlaylistSTB.prototype.addItem = function(name, data, overwrite){
        var tmp;
        if (name) {
            // as Playlist
            if (this.getEntry(name)){                
                // item with the same name found
                if (overwrite) {
                //.........
                }
            }
            else{
                // create new Playlist
                var entry = new PlaylistSTB(name,this.path);
                for (var i=0; i<data.length; i++) {
                    tmp = plman_convertToPlaylistEntry(data[i],this.path);
                    if (tmp) {
                        entry.data.push(tmp);
                    }
                }
                this.data.push(entry);
            }
        }
        else{ 
            // as Entry
            var tmp;
            for (var i=0; i<data.length; i++) {
                var item = data[i];//here we see all existing elements
                if (this.getEntry(item.name)) {
                    if (overwrite) {
                        this.replaceEntry(item);
                    }
                }
                else{
                    tmp = plman_convertToPlaylistEntry(item,this.path);
                    if (tmp) {
                        this.data.push(tmp);
                    }
                }
            }
        }
        var rootNode = this.path.split('/')[0];
        if (rootNode == ROOT_TV_CHANNELS) {
            plman.reindexTVChannels();
        }
        return true;
    };

    //**************************************************
    // METHOD: индексирование всех каналов данной группы
    PlaylistSTB.prototype.indexIt = function (lastIndex){
        var node, groups=[], index=lastIndex;
        for (var i=0, len=this.data.length; i<len; i++) {
            node = this.data[i];
            if (node.fileType == FILE_TYPE_PLAYLIST_STB) {
                groups.push(node);
            }
            else{
                node.index = ++index;
            }
        }
        for (var i=0, len=groups.length; i<len; i++) {
            node = groups[i];
            index = node.indexIt(index);
        }
        return index;
    };

    //************************************************
    // METHOD: returns node from array if it exists
    PlaylistSTB.prototype.getEntry = function (name){
        for (var i=0; i<this.data.length; i++) {
            if (this.data[i].name == name) {
                return this.data[i];
            }
        }
        return null;
    };

    //*************************************************
    // METHOD: replaces node in data array with new one
    PlaylistSTB.prototype.replaceEntry = function (item){
        for (var i=0; i<this.data.length; i++) {
            if (this.data[i].name == item.name) {
                this.data[i] = item;
                break;
            }
        }
    };

    //************************************************
    // METHOD: returns ARRAY of nodes which are groups
    // Inserts PATH property in each Group-objects
    // Path = path includs name of THIS node without slash at the end
    PlaylistSTB.prototype.getAllGroups = function (){
        this.path = this.name;
        var all = [this];
        var allGroups = group_getAllGroups(this, this.path+'/', all);
        return allGroups;
    };

    function group_getAllGroups(node,path,all){
        for (var i=0; i<node.data.length; i++) {
            var item = node.data[i];
            if (item.fileType == FILE_TYPE_PLAYLIST_STB) {
                item.path = path + item.name;
                all.push(item);
                group_getAllGroups(item, item.path+'/',all);
            }
        }
        return all;
    };

    //************************************************
    // METHOD "Сортировать элементы группы"
    PlaylistSTB.prototype.sortIt = function(){
        var item;
        var root = this.path.split('/');
        var groups = [];
        var entries = [];
        var tmp = [];
        for (var i=0; i<this.data.length; i++) {
            item = this.data[i];
            if (item.fileType == FILE_TYPE_PLAYLIST_STB) {
                groups.push(item);
            }
            else{
                entries.push(item);
            }
        }
        groups = group_sorting_ABC(groups,'name');
        if (root[0] == ROOT_TV_CHANNELS) {
            entries = group_sorting_ABC(entries,'index');
        }
        else{
            entries = group_sorting_ABC(entries,'name');
        }
        this.data = groups.concat(entries);
    };

    // mode = 'name' | 'index'
    function group_sorting_ABC(array,mode){
        var arr = [], resArray = [], add;
        for (var i=0; i<array.length; i++) {
            var key;
            if (array[i].index && mode == 'index') {
                switch (array[i].index.toString().length) {
                    case 1:
                        add = '00';
                        break;
                    case 2:
                        add = '0';
                        break;
                    case 3:
                        add = '';
                        break;
                }
                key = add + array[i].index;
            }
            else{
                key = array[i].name;
            }
            arr.push(key + '@' + i);
        }
        arr = arr.sort();
        for (var i=0; i<arr.length; i++) {
            var a = arr[i].split('@');
            var item = array[a[1]];
            resArray.push(item);
        }
        return resArray;
    }

    //************************************************
    // METHOD "Редактировать группу"
    PlaylistSTB.prototype.editGroup = function (newName, attr, psw) {
        this.accessAttr = attr;
        if (psw) {
            this.password = psw;
        }
        this.name = newName;
        var path = this.path.split('/');
        this.renamePath(path.length-1,newName);
    };

    //************************************************
    // METHOD "Переименовать путь группы"
    PlaylistSTB.prototype.renamePath = function (level,newName){
        var path = this.path.split('/');
        path[level] = newName;
        this.path = group_pathToString(path);
        for (var i=0; i<this.data.length; i++) {
            var item = this.data[i];
            if (item.fileType == FILE_TYPE_PLAYLIST_STB) {
                item.renamePath(level,newName);
            }
        }
    };

    function group_pathToString(pathArray){
        var b = '';
        for (var i=0; i<pathArray.length; i++) {
            if (i) {
                b += '/';
            }
            b += pathArray[i];
        }
        return b;
    }
    //************************************************
    // METHOD "Редактировать элемент"
    // name & source = key (по ним идентифицируем объект)
    PlaylistSTB.prototype.editItem = function (oldName, name, oldSource, source){
        _debug("PlaylistSTB.prototype.editItem() : ENTERED > oldName=" + oldName + ", name="+name +", oldSource ="+ oldSource + ", source=" +source);
        //
        // 
        // 
        // 
        //-------- DEBUG CODE
        //var str = '';
        //for (var i=0; i<this.data.length; i++) {
        //  item = this.data[i];
        //  str += 'name: "' + item.name + '", source: "' + item.source + '"\n';
        //}
        //_debug("=====================\n "+str+"\n=====================");
        //-------- DEBUG CODE
        //
        // 
        // 
        // 
        var item, key;
        for (var i=0; i<this.data.length; i++) {
            item = this.data[i];
            if(item.data){
                recursive_search(oldName, name, oldSource, source, item.data);
                continue;
            }
            if (oldSource) {
                key = (item.name == oldName) && (item.source == oldSource);
            }
            else{
                key = (item.name == oldName);
            }
            if (key) {
                // item found
                _debug("PlaylistSTB.prototype.editItem(): BEFORE DATA CHANGING > item.name = "+item.name + ", item.source = "+item.source);
                item.name = name;
                if (oldSource) {
                    item.source = source;
                }
                _debug("PlaylistSTB.prototype.editItem(): AFTER DATA CHANGING > item.name = "+item.name + ", item.source = "+item.source);
                break;
            }
        }
    };
 
    function recursive_search(oldName, name, oldSource, source, data){
        var item, key;
        for (var i=0; i<data.length; i++) {
            item = data[i];
            if(item.data){
                recursive_search(oldName, name, oldSource, source, item.data);
                continue;
            }
            if (oldSource) {
                key = (item.name == oldName.replace(/.*\//mig,"")) && (item.source == oldSource);
            }
            else{
                key = (item.name == oldName);
            }
            if (key) {
                // item found
                _debug("PlaylistSTB.prototype.editItem(): BEFORE DATA CHANGING > item.name = "+item.name + ", item.source = "+item.source);
                item.name = name.replace(/.*\//mig,"");
                if (oldSource) {
                    item.source = source;
                }
                _debug("PlaylistSTB.prototype.editItem(): AFTER DATA CHANGING > item.name = "+item.name + ", item.source = "+item.source);
                break;
            }
        }
    }

    //******************************************************
    // METHOD "Удалить элемент (массив элементов)" у группы
    //
    PlaylistSTB.prototype.deleteItem = function(arrToDelete,keepIdx){
        var curItemName;
        for (var i=0; i<arrToDelete.length; i++) {
            curItemName = arrToDelete[i].name;
            for (var j=0; j<this.data.length; j++) {
                var item = this.data[j];
                if (item.name == curItemName) {
                    /*
        if (item.index && !keepIdx) {
          plman.freeIndex(item.index);
        }
        */
                    this.data.splice(j,1);
                    break;
                }
            }
        }
        // процесс удаления закончен. Если это ТВ Каналы - все переиндексируем
        if (this.name == ROOT_TV_CHANNELS) {
            plman.reindexTVChannels();
        }
    };