﻿/*********************************************************
*
*   03.03.2010 - 25.06.2010
*
*   ПОДДЕРЖКА РАЗРЕШЕНИЙ  720x576, 1280x720, 1920x1080
*   ПОДДЕРЖКА ЯЗЫКОВ:     русский, English
*   РАБОТА С ПЛЕЙЛИСТАМИ
*
**********************************************************/
function getBrowserType(){
  var appCodeName = navigator.appCodeName;
  var appName = navigator.appName;
  var platform = navigator.platform;
  var userAgent = navigator.userAgent;
  alert("appCodeName="+appCodeName+"\n" +", appName="+appName+"\n" +", platform="+platform+"\n" +", userAgent="+userAgent);
}

// Функция выделяет из url схему (сетевой протокол) и имя хоста
// Возвращает объект: { protocol: STRING, hostname: STRING }
// где hostname - часть имени хоста или его IP до первого слэша
function getProtoAndHostname(url){
  var hostname, arr, res = {};
  var i = url.indexOf(':\/\/');
  if (i == -1){
    res.protocol = '';
    hostname = url;
  }
  else{
    res.protocol = url.substr(0,i);
    hostname = url.substring(i+2);
  }
  arr = hostname.split('/');
  res.hostname = arr[0];
  return res;
}

// Динамическая подгрузка файла скрипта
//   src = URL подгружаемого файла
//   onLoad = функция, вызываемая после его загрузки
function loadScript(src, onLoad){
  var elem = document.createElement('script');
  elem.setAttribute('language','JavaScript');
  elem.setAttribute('src',src);
  if (onLoad) {
    elem.setAttribute('onLoad',onLoad);
  }
  document.getElementsByTagName('head')[0].appendChild(elem);
}

// Динамическая подгрузка файла CSS
// src = URL подгружаемого файла
function loadStyle(src){
  var elem = document.createElement('link');
  elem.setAttribute('rel','stylesheet');
  elem.setAttribute('type','text/css');
  elem.setAttribute('href',src);
  document.getElementsByTagName('head')[0].appendChild(elem);
}

// Динамическая подгрузка скрипта БЕЗ КЕШИРОВАНИЯ
function loadScriptNoCache(src, onLoad){
  var ms = new Date().getTime().toString();
  var seed = "?" + ms; 
  loadScript(src + seed, onLoad);
}

//an alias of String.fromCharCode
function chr(code)
{
	return String.fromCharCode(code);
}

//returns utf8 encoded charachter of a unicode value.
//code must be a number indicating the Unicode value.
//returned value is a string between 1 and 4 charachters.
function code2utf(code)
{
	if (code < 128) return chr(code);
	if (code < 2048) return chr(192+(code>>6)) + chr(128+(code&63));
	if (code < 65536) return chr(224+(code>>12)) + chr(128+((code>>6)&63)) + chr(128+(code&63));
	if (code < 2097152) return chr(240+(code>>18)) + chr(128+((code>>12)&63)) + chr(128+((code>>6)&63)) + chr(128+(code&63));
}

//it is a private function for internal use in utf8Encode function 
function _utf8Encode(str)
{	
	var utf8str = new Array();
	for (var i=0; i<str.length; i++) {
		utf8str[i] = code2utf(str.charCodeAt(i));
	}
	return utf8str.join('');
}

//Encodes a unicode string to UTF8 format.
function utf8Encode(str)
{	
	var utf8str = new Array();
	var pos,j = 0;
	var tmpStr = '';
	
	while ((pos = str.search(/[^\x00-\x7F]/)) != -1) {
		tmpStr = str.match(/([^\x00-\x7F]+[\x00-\x7F]{0,10})+/)[0];
		utf8str[j++] = str.substr(0, pos);
		utf8str[j++] = _utf8Encode(tmpStr);
		str = str.substr(pos + tmpStr.length);
	}
	
	utf8str[j++] = str;
	return utf8str.join('');
}

var Utf8 = {
 
    // public method for url encoding
    encode : function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }
        }
        return utftext;
    },
    // public method for url decoding
    decode : function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
 
        while ( i < utftext.length ) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    }
}



// returns object { width:value, height:value }
function getResolution(){
  var w, h;
  if (!STB_EMULATION) {
    w = screen.width;
    h = screen.height;
  }
  else{
    switch (DEBUG_WIDTH) {
      case '720':
        w = 720;
        h = 576;
        break;
      case '1280':
        w = 1280;
        h = 720;
        break;
      case '1920':
        w = 1920;
        h = 1080;
        break;
      default:
        alert('ARE YOU REALLY CRAZY OR WHAT ?!...\n Look at "DEBUG_WIDTH" in vars.js!');
    }
  }
  videoMode = getCurrentVideoOutMode();
  var res = {width : w , height : h};
  return res;
}

function resizeBrowserWindow (width, height){
  if (DEBUG_BIG_RESOLUTION && !STB_EMULATION) {
    if (width && height) {
      window.moveTo(0,0);
      window.resizeTo (width, height);
    }
  }
}

// возвращает текущий режим графического разрешения (INT):
function getCurrentGraphicResolution(){
  var GRes = "720";                 // default value
  if (!STB_EMULATION) {
    try{
      GRes = stb.RDir("gmode")//getEnvironmentValue("graphicres");      // GRes = '720p' |'1280' | '1920'
    }catch(e){
      _debug('graphicres ERROR: '+e);
    }
  }
  _debug('GRes = '+GRes);
  
  if(GRes == 'tvsystem_res'){
  	GRes = eval("GMODE_"+GResArr[getCurrentVideoOutMode()]);
  }
  else{
	  GRes = eval("GMODE_"+GRes);
  }
  return GRes;
}


// возвращает текущий режим видео-выхода (INT):
function getCurrentVideoOutMode(){
  var vmode = "576i";                 // default value
  if (!STB_EMULATION) {
    try{
      vmode = stb.RDir("vmode");      // vmode = '576i' | '576p' | '720p' |'1080i' | '480i'|'720p60'|'1080i60'|
    }catch(e){
      _debug('vmode ERROR: '+e);
    }
  }
  _debug('vmode = '+vmode);

	  
  if (vmode == "576i" || vmode == "720p" || vmode == "1080i" || vmode == "720p60" || vmode == "1080i60") {
    vmode = eval("MODE_"+vmode);
  }
  else{
    vmode = MODE_576i;
  }
  return vmode;
}

// Функция проверяет наличие записей о порталах в CFG и возвращает их количество от 0
function check_portals(){
  var ret = 0;
  if (portal_1 = getPortalName('portal1'))       // getPortalName("Portal1")    
    ret++;
  if (portal_2 = getPortalName('portal2'))       // getPortalName("Portal2")
    ret++;
  return ret;
}

// Читает из STB и возвращает адрес портала без "http://"
function getPortalName(name){
  var pat = '', addr, tmp;
  if (!USE_ENVIRONMENT_VARS){
    pat = eval('pat_'+name);
  }
  addr = readFromStb_URL (name, pat);
  if (addr) {
    pat = "http://";
    tmp = addr.substr(0,pat.length);
    if (tmp == pat){
      addr = addr.substr (pat.length, addr.length-pat.length);
    }
  }
  return addr;
}

function lowCaser(string) {  //функция преобразования в нижний регистр
    return string.substr(0).toLowerCase(); 
}

function empty(mixed_var) {         //проверка на все варианты отсутсвия значения
    if (mixed_var === "" ||
        mixed_var === 0 ||
        mixed_var === "0" ||
        mixed_var === null ||
        mixed_var === false ||
        typeof mixed_var === 'undefined' ||
        typeof mixed_var === 'NaN'
    ) {
        return true;
    }
    if (typeof mixed_var == 'object') {
        for (var key in mixed_var) {
            return false;
        }
        return true;
    }
    return false;
}

// Вычитываем из приставки значение переменной текущего языка
function getCurrentLanguage(){
  var lang = 0;
  if (!LANGUAGE_ENGLISH_ONLY) {
    if (USE_ENVIRONMENT_VARS){
      // Читаем из среды окружения
      lang_t = getEnvironmentValue('language');
	  lang = lowCaser(lang_t);   
	  _debug("portal var lang = "+lang);
    }		
    else {
      // Читаем из STB_PARAMS
      var pat  = /[\n\w\S\s]*LANGUAGE="([\S]*)"[\n\w\S\s]*/;
      var str  = '';
      cfg ? str = cfg : str = read_cfg();
      lang = str.replace(pat, "$1");
    }
//    lang = parseInt(lang);
//    if (isNaN(lang)) {
//      lang = 0;
//    }
    // Этот код является общим для всех html-страниц, поэтому я здесь вставил код формирования транспаранта EMULATION
    if (STB_EMULATION) {
      var emul = document.getElementById('emul');
      if (emul) {
        emul.innerHTML = 'EMULATION';
        emul.style.display = 'block';
      }
    }
  }
  return lang;
}

// Файл ресурсов для данного языка не загрузился
function languageResourcesFailed(lang){
  var err_msg = ERROR_NO_LANGUAGE+curLangIdx+'.';
  try{
    if (failTimer){
      delete failTimer;
    }
  } catch (e){
    _debug(e);
  }
  if (STB_EMULATION){
    myError(err_msg);
  }
  else{
    _debug(err_msg);
	_debug('loaded default language');
	curLangIdx = 'en';
	loadScript ('lang/'+curLangIdx+'/resource.js', 'fillPage()');
  }
}

// Additional checking whether loaded language resources file is valid
// returns boolean
function checkLanguageResourceFile(){
  var err_msg = ERROR_NO_LANGUAGE + curLangIdx + '.',
      result  = false;
try{
  if (failTimer) {
    clearTimeout(failTimer);
    delete failTimer;
  }
}
catch(e){}
  try {
    if (languageList) {
      _debug("Language Resources have been loaded successfully. Number of supported languages is "+languageList.length);
      result = true;
    }
    else{
      myError(err_msg);
    }
  } catch(e){
    myError(err_msg);
  }
  return result;
}

// Возвращает значение переменной среды окружения по ее имени (читает из BootLoader'a)
function getEnvironmentValue(name){
  var value;
  if (STB_EMULATION){
    try{
      value = eval('debug_' + name);
    }catch (e){
    }
  }
  else{
    value = stb.RDir('getenv ' + name);
  }
  return value;
}

// Устанавливает переменную среды окружения в указанное значение (пишет в BootLoader)
function setEnvironmentValue(name, value){
  var strout = 'Saving ' + name + ' = ';
  if (OUTPUT_CHAR_CODES) {
    strout += convertToCharCode(value);
  }
  else{
    strout += value;
  }
  if (STB_EMULATION){
    _debug(name + ' = ' + value);
  }
  else{
      _debug(name+' : '+value);
    stb.RDir('setenv ' + name + ' ' + value);
  }
  _debug (strout);
}

// Пакетная установка переменных окружения во флэше
function batchSetEnvValues(str){
  var strout = 'BATCH Saving :' + str;
  if (STB_EMULATION){
    //.........
  }
  else{
    stb.RDir('setenv ' + str);
  }
  _debug (strout);
}


function empty(mixed_var) {
    if (mixed_var === "" ||
        mixed_var === 0 ||
        mixed_var === "0" ||
        mixed_var === null ||
        mixed_var === false ||
        typeof mixed_var === 'undefined' ||
        typeof mixed_var === 'NaN'
    ) {
        return true;
    }
    if (typeof mixed_var == 'object') {
        for (var key in mixed_var) {
            return false;
        }
        return true;
    }
    return false;
}

// Возвращает стринг в виде последовательности кодов всех символов исходного стринга
function convertToCharCode(_str_){
  var res_str = '';
  for (var i=0; i<_str_.length; i++) {
    res_str += _str_.charCodeAt(i);
    res_str += '|';
  }
  return res_str;
}

// Возвращает версию сборки образа ПО
function getBuildVersion(){
  var ver;
  var version = "Version : ";
  if (STB_EMULATION){
    ver = 'Firmare 11.22.333 Version';
  }
  else{
    ver += stb.RDir('Img_Ver');
  }
  ver = ver.split(' ')[1];
  version += ver;
  return version;
}

// Вычитывает из приставки значение переменной типа URL
// name = имя переменной
// pat  = паттерн для RegExp
function readFromStb_URL (name,pat){
  var result;
  if (USE_ENVIRONMENT_VARS){
    // Читаем из среды окружения
    result = getEnvironmentValue(name);
  }
  else {
    // Читаем из STB_PARAMS
    var str;
    cfg ? str = cfg : str = read_cfg();
    if (str.match(pat,"$1")) {
      result = str.replace(pat,"$1");
    }
    else {
      switch (name){
        case 'portal1':
          result = PORTAL1_DEFAULT_URL;
          break;
        case 'portal1':
          result = '';
          break;
      }
    }
  }
  return result;
}

//---------------------------------------------------------------------------
/* 
 ЗАГРУЗЧИК внешних файлов скриптов или стилей
  Формат параметра filesQueue:
  [
    {
      src     : 'a.js',               // имя файла загружаемого скрипта
      onLoad  : loaded_a,             // имя функции коллбека, вызываемого после загрузки данного файла 
      timeout : 100                   // таймаут загрузки
    },
    .....
  ]
  Параметр onFinish - коллбек, вызываемф по окончании загрузки всей очереди скиптов */

function Loader (filesQueue, onFinish){
  this.queue    = filesQueue;                         // массив объектов для загрузки
  this.queIdx   = 0;                                  // индекс в массиве this.queue
  this.enabled  = false;                              // разрешение процесса загрузки
  this.curExt   = null;                               // расширение загружаемого файла
  this.onFinish = onFinish;
  //
  this.start    = function (){
    if (this.queue.length){
      this.enabled = true;
      this.loading();
    }
  };
  // МЕТОД "Загрузить"
  this.loading = function(){
    if (this.enabled && this.queIdx < this.queue.length){
      var elem;
      var file = this.queue[this.queIdx];
      var ext = file.src.split('.')[1];
      switch(ext){
        case 'js':
          elem = document.createElement('script');
          elem.setAttribute('language','JavaScript');
          elem.setAttribute('src', file.src);
          elem.setAttribute('onLoad', "loader.loaded()");
          break;
        case 'css':
          elem = document.createElement('link');
          elem.setAttribute('rel','stylesheet');
          elem.setAttribute('type','text/css');
          elem.setAttribute('href',file.src);
          break;
        default:
          return;  
      }
      document.getElementsByTagName('head')[0].appendChild(elem);
      this.curExt = ext;
      failTimer = setTimeout(loader_loadingFailed, file.timeout);
    }
  };
  // МЕТОД "Загрузка текущего файла завершена"
  this.loaded = function (){
    if (failTimer) {
      clearTimeout (failTimer);
    }
    if (this.queue[this.queIdx].onLoad) {
      this.queue[this.queIdx].onLoad();
    }
    if (loader.queIdx < loader.queue.length-1){
      this.queIdx ++;
      this.loading();
    }
    else{
      // Загрузка всех файлов закончена
      this.onFinish();
    }
  };
  // МЕТОД "Остановить загрузку"
  this.stop = function (){
    this.enabled = false;
  };
}

// Загрузка файла завершилась неудачей
function loader_loadingFailed(){
  if (loader) {
    switch (loader.curExt) {
      case 'css':
        // Закончился таймаут загрузки файла стилей. Мы не можем проверить, действительно ли он загрузился.
        // Просто переходим к загрузке следующего файла
        failTimer = null;
        loader.loaded();
        break;
      default:
        if(loader.queue[loader.queIdx].src = 'lang/'+ curLangIdx +'/resource.js'){
			_debug('there is no '+ curLangIdx +' localization');
			curLangIdx = 'en';
			firstLoadingStageCompleted_nolocal();			
		}
		else{
		loader.stop();
        alert (loader.queue[loader.queIdx].src + " FAILED");
		break;
		}
    }
    loader.curExt = null;
  }
}
 
var getErrorInfo_STACK_INFO = true;
function getErrorInfo(errObj){
  var b = '';
  if (errObj) {
    var CR = '\n';
    if (STB_EMULATION) {
      CR = '<br>';
    }
    if (typeof errObj == "object") {
      b += CR + CR + '----==<  JavaScript '   + errObj.name + '  >==----' + CR;
      b += 'FILE: '+ errObj.fileName    + CR;
      b += 'LINE: ' + errObj.lineNumber + CR;
      b += 'WHY: '  + errObj.message    + CR;
      if (getErrorInfo_STACK_INFO) {
        if (errObj.stack) {
          b += 'STACK: ' + errObj.stack.substr(0,250);
        }
      }
      b += CR;
    }
    else{
      b = errObj;
    }
  }
  return b;
}

function objToString(o) {
    var s = '{';
        for (var p in o)
            s += p + ': "' + o[p] + '",';
        return s + '}';
}


function sendreq(url, callback){
	    try {
	        var request = new XMLHttpRequest();
	        request.open('GET', url, true);
	        request.setRequestHeader("Content-Type", "text/xml");
	        //request.setRequestHeader("Cookie", "uper=100");
	        //request.setRequestHeader("Cookie2", "uper=100");
	        request.setRequestHeader("charset", "utf-8");
	        if (request.overrideMimeType) {
	            request.overrideMimeType('text/html');
	        }
	        request.onreadystatechange = function ()
	        {
	            if (request.readyState == 4 && request.status == 200) {
	                _debug("Url " + url + " get done");
	                var answer = request.responseText;//.replace(/<script.*?\/script>/igm,'')
	                callback(answer);
	                //setTimeout(function(){stb.EnableSetCookieFrom(".ex.ua", true);}, 500);//
	            }else{
                        if(request.readyState == 4 && (request.status == 0 || request.status == 404)){
                            newMyAlert(tv_serv_noansver,'alert');
                        }
                    }
                    _debug(request.readyState+' : '+request.status)
	        };
	        _debug("Url " + url + " request.send(null)");
	        request.send(null); // send object
	    } catch (e) {
	        _debug("catch (e): \"" + e + "\"");
	        return;
	    }
	}
        